package com.info666.infraredRemote.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.system.domain.BaseParam;
import com.ruoyi.system.domain.BasicLibrary;
import com.ruoyi.system.domain.TemplateLibrary;
import com.ruoyi.system.domain.vo.GetDeviceInfoVo;
import com.ruoyi.system.service.BasicLibraryService;
import com.ruoyi.system.service.ComponentsLibraryService;
import com.ruoyi.system.service.TemplateLibraryService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

/**
 * @Author: LiMingMing
 * @Date: 2023/7/13 15:31
 **/
@RestController
@RequestMapping("/api/v1/getInfo")
public class GetDeviceInfoController {

    @Autowired
    private BasicLibraryService basicLibraryService;

    @Autowired
    private TemplateLibraryService templateLibraryService;

    @Autowired
    private ComponentsLibraryService componentsLibraryService;

    @ApiOperation("获取遥控设备信息")
    @PostMapping("/getDeviceInfo")
    public R<List<GetDeviceInfoVo>> getDeviceInfo(@RequestBody BaseParam param) {
        List<GetDeviceInfoVo> list = new ArrayList<>();

//        List<ComponentsLibrary> componentsLibraries = new ArrayList<>();

        List<TemplateLibrary> templaList = templateLibraryService.list(new LambdaQueryWrapper<TemplateLibrary>().eq(TemplateLibrary::getDelFlag, 0));
        for (TemplateLibrary templateLibrary : templaList) {

            //获取基本数据
            BasicLibrary basicLibrary = basicLibraryService.getOne(new LambdaQueryWrapper<BasicLibrary>().eq(BasicLibrary::getDelFlag, 0)
                    .eq(BasicLibrary::getId, templateLibrary.getId()), false);
//            ArrayList<Integer> integers = new ArrayList<>();
            //按照引导次数去写入引导码
//            for (int i = 0; i < basicLibrary.getBootCodeSend(); i++) {
//                String[] bootCode = basicLibrary.getBootCode().split(",");
//                for (String s : bootCode) {
//                    integers.add(Integer.valueOf(s));
//                }
//            }
//            //数据码
//            String[] dataCode = basicLibrary.getBootCode().split(",");
//            for (String s : dataCode) {
//                integers.add(Integer.valueOf(s));
//            }
//            //结束码
//            for (String s : basicLibrary.getOverCode().split(",")) {
//                integers.add(Integer.valueOf(s));
//            }

            GetDeviceInfoVo  deviceInfoVo = new GetDeviceInfoVo();
            deviceInfoVo.setBandValue(basicLibrary.getBandValue());
            deviceInfoVo.setComponentsString(templateLibrary.getComponents());
//            deviceInfoVo.setComponentsList(componentsLibraries);
//            deviceInfoVo.setBootCodeLow(integers.toArray(new Integer[0]));
            deviceInfoVo.setBasicLibrary(basicLibrary);
            list.add(deviceInfoVo);
        }
        return R.ok(list);
    }
}
